package fireworx;

import java.sql.*;
import java.io.*;
import java.lang.*;

public class EventQueryBean extends QueryBean {
  
  private String houseCode;
  private String action;
  private String unit;

  public EventQueryBean() {
  }
  
  public boolean queryDatabase() {
  	

  	String orderBy = null;
  	String where = null;
  	  	
  	//start building sql statement  	
   	String sql = "Select EventID as ID, HouseCode, Device as Unit, Action, StartDate, EndDate, Su, Mo, Tu, We, Th, Fr, Sa, Time, Category from events";
   	
   	//build where clause
    if (houseCode != null && !houseCode.equals("*"))
    	where = ((where == null)?"":where) + " HouseCode = '" + houseCode + "' and";
    if (unit != null && !unit.equals("*"))
    	where = ((where == null)?"":where) + " Device = '"	+ unit + "' and";
    if (action != null && !action.equals("*"))
    	where = ((where == null)?"":where) + " Action = '" + action + "' and";
  
    //build order by clause
    if (sortBy != null) {
     	if (sortBy.equals("ID"))
   	  		orderBy = " order by EventID " + sortOrder;
	   	else if (sortBy.equals("HouseCode"))
  	 			orderBy = " order by HouseCode " + sortOrder + ", Device " + sortOrder;
   		else if (sortBy.equals("Unit"))
   			orderBy = " order by Device " + sortOrder + ", HouseCode " + sortOrder;
			else if (sortBy.equals("Action"))
     			orderBy = " order by Action " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
   		else if (sortBy.equals("Start Date"))
     			orderBy = " order by StartDate " + sortOrder + ", Time " + sortOrder +", HouseCode " + sortOrder + ", Device " + sortOrder;
    	else if (sortBy.equals("End Date"))
     			orderBy = " order by EndDate " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
    	else if (sortBy.equals("Time"))
     			orderBy = " order by Time " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
     	else if (sortBy.equals("Category"))
     			orderBy = " order by Category " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
     	else if (sortBy.equals("Su") | sortBy.equals("Mo") | sortBy.equals("Tu") | sortBy.equals("We") | sortBy.equals("Th") | sortBy.equals("Fr") | sortBy.equals("Sa") )
     			orderBy = " order by " + sortBy + " " + sortOrder + ", StartDate " + sortOrder + ", Time " + sortOrder;
      }
           
    //finish building sql
    if (where != null)
    	sql = sql + " where" + where.substring(0,where.length() - 4);
    
    if (orderBy != null)
      sql = sql + orderBy + ";";
          	
    System.out.println("Action = " + action + "where=" + where + "%%" + sql);
  	
  	return queryDatabase(sql);
   }
   
  //setters and getters 
  public void setHouseCode(String houseCode) {
    this.houseCode = houseCode;
  }

  public String getHouseCode() {
    return this.houseCode;
  }

  public void setUnit(String unit) {
    this.unit = unit;
  }

  public String getUnit() {
    return this.unit;
  }

  public void setAction(String action) {
    this.action = action;
  }

  public String getAction() {
    return this.action;
  }

 
}