package fireworx;

import java.sql.*;
import java.io.*;

public class HistoryQueryBean extends QueryBean {
  
  private String houseCode;
  private String action;
  private String unit;


  public HistoryQueryBean() {
  }
  
  public boolean queryDatabase() {
  	

  	String orderBy = null;
  	String where = null;
  	  	
   	String sql = "Select EventID as ID, HouseCode, Device as Unit, Action, Date, Time from history";
  
    //build where clause
    if (houseCode != null && !houseCode.equals("*"))
    	where = ((where == null)?"":where) + " HouseCode = '" + houseCode + "' and";
    if (unit != null && !unit.equals("*"))
    	where = ((where == null)?"":where) + " Device = '"	+ unit + "' and";
    if (action != null && !action.equals("*"))
    	where = ((where == null)?"":where) + " Action = '" + action + "' and";
  
  
    if (sortBy != null) {
     	if (sortBy.equals("ID"))
     			orderBy = " order by EventID " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
     	else if (sortBy.equals("HouseCode"))
     			orderBy = " order by HouseCode " + sortOrder + ", Device " + sortOrder;
     	else if (sortBy.equals("Unit"))
     			orderBy = " order by Device " + sortOrder + ", HouseCode " + sortOrder;
			else if (sortBy.equals("Action"))
     			orderBy = " order by Action " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
   		else if (sortBy.equals("Date"))
     			orderBy = " order by Date " + sortOrder + ", Time " + sortOrder +", HouseCode " + sortOrder + ", Device " + sortOrder;
    	else if (sortBy.equals("Time"))
     			orderBy = " order by Time " + sortOrder + ", HouseCode " + sortOrder + ", Device " + sortOrder;
    }
    
    //finish building sql
    if (where != null)
    	sql = sql + " where" + where.substring(0,where.length() - 4);
    
    if (orderBy != null)
      sql = sql + orderBy + ";";
          	
    System.out.println("sortBy = " + sortBy + "sql = " + sql);
   
    return queryDatabase(sql);
   }
   
 
  public void setHouseCode(String houseCode) {
    this.houseCode = houseCode;
  }

  public String getHouseCode() {
    return this.houseCode;
  }
  
   public void setUnit(String unit) {
    this.unit = unit;
  }

  public String getUnit() {
    return this.unit;
  }

  public void setAction(String action) {
    this.action = action;
  }

  public String getAction() {
    return this.action;
  }

 
}